diff -ur pdns-4.5.0/pdns/responsestats.cc pdns-4.5.0-2021-01/pdns/responsestats.cc
--- pdns-4.5.0/pdns/responsestats.cc	2021-05-06 20:20:28.000000000 +0200
+++ pdns-4.5.0-2021-01/pdns/responsestats.cc	2021-07-16 14:05:36.000000000 +0200
@@ -27,11 +27,11 @@
 ResponseStats::ResponseStats() :
   d_sizecounters("SizeCounters", sizeBounds())
 {
-  for (unsigned int n = 0; n < 65535; ++n) {
-    d_qtypecounters[n].value = 0;
+  for (auto& entry : d_qtypecounters) {
+    entry.value = 0;
   }
-  for (unsigned int n = 0; n < 256; ++n) {
-    d_rcodecounters[n].value = 0;
+  for (auto& entry : d_rcodecounters) {
+    entry.value = 0;
   }
 }
 
@@ -53,7 +53,7 @@
 {
   map<uint16_t, uint64_t> ret;
   uint64_t count;
-  for (unsigned int i = 0; i < 65535; ++i) {
+  for (unsigned int i = 0; i < d_qtypecounters.size(); ++i) {
     count = d_qtypecounters.at(i).value;
     if (count) {
       ret[i] = count;
@@ -77,7 +77,7 @@
 {
   map<uint8_t, uint64_t> ret;
   uint64_t count;
-  for (unsigned int i = 0; i < 256; ++i) {
+  for (unsigned int i = 0; i < d_rcodecounters.size(); ++i) {
     count = d_rcodecounters.at(i).value;
     if (count) {
       ret[i] = count;
diff -ur pdns-4.5.0/pdns/responsestats.hh pdns-4.5.0-2021-01/pdns/responsestats.hh
--- pdns-4.5.0/pdns/responsestats.hh	2021-07-12 20:43:04.000000000 +0200
+++ pdns-4.5.0-2021-01/pdns/responsestats.hh	2021-07-16 14:18:02.000000000 +0200
@@ -45,7 +45,7 @@
     mutable std::atomic<uint64_t> value;
   };
 
-  std::array<Counter, 65535> d_qtypecounters;
+  std::array<Counter, 65536> d_qtypecounters;
   std::array<Counter, 256> d_rcodecounters;
   pdns::AtomicHistogram<uint64_t> d_sizecounters;
 };
